extern (C) :

alias byte   ALboolean;
alias byte   ALchar;
alias byte   ALbyte;
alias ubyte  ALubyte;
alias short  ALshort;
alias ushort ALushort;
alias int    ALint;
alias uint   ALuint;
alias int    ALsizei;
alias int    ALenum;
alias float  ALfloat;
alias double ALdouble;
alias void   ALvoid;

const uint AL_INVALID                                = -1 ;
const uint AL_NONE                                   = 0 ;
const uint AL_FALSE                                  = 0 ;
const uint AL_TRUE                                   = 1 ;
const uint AL_SOURCE_RELATIVE                        = 0x202 ;
const uint AL_CONE_INNER_ANGLE                       = 0x1001 ;
const uint AL_CONE_OUTER_ANGLE                       = 0x1002 ;
const uint AL_PITCH                                  = 0x1003 ;
const uint AL_POSITION                               = 0x1004 ;
const uint AL_DIRECTION                              = 0x1005 ;
const uint AL_VELOCITY                               = 0x1006 ;
const uint AL_LOOPING                                = 0x1007 ;
const uint AL_BUFFER                                 = 0x1009 ;
const uint AL_GAIN                                   = 0x100A ;
const uint AL_MIN_GAIN                               = 0x100D ;
const uint AL_MAX_GAIN                               = 0x100E ;
const uint AL_ORIENTATION                            = 0x100F ;
const uint AL_CHANNEL_MASK                           = 0x3000 ;
const uint AL_SOURCE_STATE                           = 0x1010 ;
const uint AL_INITIAL                                = 0x1011 ;
const uint AL_PLAYING                                = 0x1012 ;
const uint AL_PAUSED                                 = 0x1013 ;
const uint AL_STOPPED                                = 0x1014 ;
const uint AL_BUFFERS_QUEUED                         = 0x1015 ;
const uint AL_BUFFERS_PROCESSED                      = 0x1016 ;
const uint AL_SEC_OFFSET                             = 0x1024 ;
const uint AL_SAMPLE_OFFSET                          = 0x1025 ;
const uint AL_BYTE_OFFSET                            = 0x1026 ;
const uint AL_SOURCE_TYPE                            = 0x1027 ;
const uint AL_STATIC                                 = 0x1028 ;
const uint AL_STREAMING                              = 0x1029 ;
const uint AL_UNDETERMINED                           = 0x1030 ;
const uint AL_FORMAT_MONO8                           = 0x1100 ;
const uint AL_FORMAT_MONO16                          = 0x1101 ;
const uint AL_FORMAT_STEREO8                         = 0x1102 ;
const uint AL_FORMAT_STEREO16                        = 0x1103 ;
const uint AL_REFERENCE_DISTANCE                     = 0x1020 ;
const uint AL_ROLLOFF_FACTOR                         = 0x1021 ;
const uint AL_CONE_OUTER_GAIN                        = 0x1022 ;
const uint AL_MAX_DISTANCE                           = 0x1023 ;
const uint AL_FREQUENCY                              = 0x2001 ;
const uint AL_BITS                                   = 0x2002 ;
const uint AL_CHANNELS                               = 0x2003 ;
const uint AL_SIZE                                   = 0x2004 ;
const uint AL_UNUSED                                 = 0x2010 ;
const uint AL_PENDING                                = 0x2011 ;
const uint AL_PROCESSED                              = 0x2012 ;
const uint AL_NO_ERROR                               = AL_FALSE ;
const uint AL_INVALID_NAME                           = 0xA001 ;
const uint AL_ILLEGAL_ENUM                           = 0xA002 ;
const uint AL_INVALID_ENUM                           = 0xA002 ;
const uint AL_INVALID_VALUE                          = 0xA003 ;
const uint AL_ILLEGAL_COMMAND                        = 0xA004 ;
const uint AL_INVALID_OPERATION                      = 0xA004 ;
const uint AL_OUT_OF_MEMORY                          = 0xA005 ;
const uint AL_VENDOR                                 = 0xB001 ;
const uint AL_VERSION                                = 0xB002 ;
const uint AL_RENDERER                               = 0xB003 ;
const uint AL_EXTENSIONS                             = 0xB004 ;
const uint AL_DOPPLER_FACTOR                         = 0xC000 ;
const uint AL_DOPPLER_VELOCITY                       = 0xC001 ;
const uint AL_SPEED_OF_SOUND                         = 0xC003 ;
const uint AL_DISTANCE_MODEL                         = 0xD000 ;
const uint AL_INVERSE_DISTANCE                       = 0xD001 ;
const uint AL_INVERSE_DISTANCE_CLAMPED               = 0xD002 ;
const uint AL_LINEAR_DISTANCE                        = 0xD003 ;
const uint AL_LINEAR_DISTANCE_CLAMPED                = 0xD004 ;
const uint AL_EXPONENT_DISTANCE                      = 0xD005 ;
const uint AL_EXPONENT_DISTANCE_CLAMPED              = 0xD006 ;


extern(C) /*export*/  void          alEnable( ALenum capability );
extern(C) /*export*/  void          alDisable( ALenum capability );
extern(C) /*export*/  ALboolean     alIsEnabled( ALenum capability );
extern(C) /*export*/  ALchar*       alGetString( ALenum param );
extern(C) /*export*/  void          alGetBooleanv( ALenum param, ALboolean* data );
extern(C) /*export*/  void          alGetIntegerv( ALenum param, ALint* data );
extern(C) /*export*/  void          alGetFloatv( ALenum param, ALfloat* data );
extern(C) /*export*/  void          alGetDoublev( ALenum param, ALdouble* data );
extern(C) /*export*/  ALboolean     alGetBoolean( ALenum param );
extern(C) /*export*/  ALint         alGetInteger( ALenum param );
extern(C) /*export*/  ALfloat       alGetFloat( ALenum param );
extern(C) /*export*/  ALdouble      alGetDouble( ALenum param );
extern(C) /*export*/  ALenum        alGetError( );
extern(C) /*export*/  ALboolean     alIsExtensionPresent( const ALchar* extname );
extern(C) /*export*/  void*         alGetProcAddress( const ALchar* fname );
extern(C) /*export*/  ALenum        alGetEnumValue( const ALchar* ename );
extern(C) /*export*/  void          alListenerf( ALenum param, ALfloat value );
extern(C) /*export*/  void          alListener3f( ALenum param, ALfloat value1, ALfloat value2, ALfloat value3 );
extern(C) /*export*/  void          alListenerfv( ALenum param, const ALfloat* values );
extern(C) /*export*/  void          alListeneri( ALenum param, ALint value );
extern(C) /*export*/  void          alListener3i( ALenum param, ALint value1, ALint value2, ALint value3 );
extern(C) /*export*/  void          alListeneriv( ALenum param, const ALint* values );
extern(C) /*export*/  void          alGetListenerf( ALenum param, ALfloat* value );
extern(C) /*export*/  void          alGetListener3f( ALenum param, ALfloat *value1, ALfloat *value2, ALfloat *value3 );
extern(C) /*export*/  void          alGetListenerfv( ALenum param, ALfloat* values );
extern(C) /*export*/  void          alGetListeneri( ALenum param, ALint* value );
extern(C) /*export*/  void          alGetListener3i( ALenum param, ALint *value1, ALint *value2, ALint *value3 );
extern(C) /*export*/  void          alGetListeneriv( ALenum param, ALint* values );
extern(C) /*export*/  void          alGenSources( ALsizei n, ALuint* sources );
extern(C) /*export*/  void          alDeleteSources( ALsizei n, const ALuint* sources );
extern(C) /*export*/  ALboolean     alIsSource( ALuint sid );
extern(C) /*export*/  void          alSourcef( ALuint sid, ALenum param, ALfloat value );
extern(C) /*export*/  void          alSource3f( ALuint sid, ALenum param, ALfloat value1, ALfloat value2, ALfloat value3 );
extern(C) /*export*/  void          alSourcefv( ALuint sid, ALenum param, const ALfloat* values );
extern(C) /*export*/  void          alSourcei( ALuint sid, ALenum param, ALint value );
extern(C) /*export*/  void          alSource3i( ALuint sid, ALenum param, ALint value1, ALint value2, ALint value3 );
extern(C) /*export*/  void          alSourceiv( ALuint sid, ALenum param, const ALint* values );
extern(C) /*export*/  void          alGetSourcef( ALuint sid, ALenum param, ALfloat* value );
extern(C) /*export*/  void          alGetSource3f( ALuint sid, ALenum param, ALfloat* value1, ALfloat* value2, ALfloat* value3);
extern(C) /*export*/  void          alGetSourcefv( ALuint sid, ALenum param, ALfloat* values );
extern(C) /*export*/  void          alGetSourcei( ALuint sid, ALenum param, ALint* value );
extern(C) /*export*/  void          alGetSource3i( ALuint sid, ALenum param, ALint* value1, ALint* value2, ALint* value3);
extern(C) /*export*/  void          alGetSourceiv( ALuint sid, ALenum param, ALint* values );
extern(C) /*export*/  void          alSourcePlayv( ALsizei ns, const ALuint *sids );
extern(C) /*export*/  void          alSourceStopv( ALsizei ns, const ALuint *sids );
extern(C) /*export*/  void          alSourceRewindv( ALsizei ns, const ALuint *sids );
extern(C) /*export*/  void          alSourcePausev( ALsizei ns, const ALuint *sids );
extern(C) /*export*/  void          alSourcePlay( ALuint sid );
extern(C) /*export*/  void          alSourceStop( ALuint sid );
extern(C) /*export*/  void          alSourceRewind( ALuint sid );
extern(C) /*export*/  void          alSourcePause( ALuint sid );
extern(C) /*export*/  void          alSourceQueueBuffers( ALuint sid, ALsizei numEntries, const ALuint *bids );
extern(C) /*export*/  void          alSourceUnqueueBuffers( ALuint sid, ALsizei numEntries, ALuint *bids );
extern(C) /*export*/  void          alGenBuffers( ALsizei n, ALuint* buffers );
extern(C) /*export*/  void          alDeleteBuffers( ALsizei n, const ALuint* buffers );
extern(C) /*export*/  ALboolean     alIsBuffer( ALuint bid );
extern(C) /*export*/  void          alBufferData( ALuint bid, ALenum format, const ALvoid* data, ALsizei size, ALsizei freq );
extern(C) /*export*/  void          alBufferf( ALuint bid, ALenum param, ALfloat value );
extern(C) /*export*/  void          alBuffer3f( ALuint bid, ALenum param, ALfloat value1, ALfloat value2, ALfloat value3 );
extern(C) /*export*/  void          alBufferfv( ALuint bid, ALenum param, const ALfloat* values );
extern(C) /*export*/  void          alBufferi( ALuint bid, ALenum param, ALint value );
extern(C) /*export*/  void          alBuffer3i( ALuint bid, ALenum param, ALint value1, ALint value2, ALint value3 );
extern(C) /*export*/  void          alBufferiv( ALuint bid, ALenum param, const ALint* values );
extern(C) /*export*/  void          alGetBufferf( ALuint bid, ALenum param, ALfloat* value );
extern(C) /*export*/  void          alGetBuffer3f( ALuint bid, ALenum param, ALfloat* value1, ALfloat* value2, ALfloat* value3);
extern(C) /*export*/  void          alGetBufferfv( ALuint bid, ALenum param, ALfloat* values );
extern(C) /*export*/  void          alGetBufferi( ALuint bid, ALenum param, ALint* value );
extern(C) /*export*/  void          alGetBuffer3i( ALuint bid, ALenum param, ALint* value1, ALint* value2, ALint* value3);
extern(C) /*export*/  void          alGetBufferiv( ALuint bid, ALenum param, ALint* values );
extern(C) /*export*/  void          alDopplerFactor( ALfloat value );
extern(C) /*export*/  void          alDopplerVelocity( ALfloat value );
extern(C) /*export*/  void          alSpeedOfSound( ALfloat value );
extern(C) /*export*/  void          alDistanceModel( ALenum distanceModel );



extern (C) struct ALCdevice_struct { }
extern (C) struct ALCcontext_struct { }
alias ALCdevice_struct ALCdevice;
alias ALCcontext_struct ALCcontext;

alias byte   ALCboolean;
alias byte   ALCchar;
alias byte   ALCbyte;
alias ubyte  ALCubyte;
alias short  ALCshort;
alias ushort ALCushort;
alias int    ALCint;
alias uint   ALCuint;
alias int    ALCsizei;
alias int    ALCenum;
alias float  ALCfloat;
alias double ALCdouble;
alias void   ALCvoid;


extern(C) /*export*/  ALCcontext *  alcCreateContext( ALCdevice *device, const ALCint* attrlist );
extern(C) /*export*/  ALCboolean    alcMakeContextCurrent( ALCcontext *context );
extern(C) /*export*/  void          alcProcessContext( ALCcontext *context );
extern(C) /*export*/  void          alcSuspendContext( ALCcontext *context );
extern(C) /*export*/  void          alcDestroyContext( ALCcontext *context );
extern(C) /*export*/  ALCcontext *  alcGetCurrentContext( );
extern(C) /*export*/  ALCdevice*    alcGetContextsDevice( ALCcontext *context );
extern(C) /*export*/  ALCdevice *   alcOpenDevice( const ALCchar *devicename );
extern(C) /*export*/  ALCboolean    alcCloseDevice( ALCdevice *device );
extern(C) /*export*/  ALCenum       alcGetError( ALCdevice *device );
extern(C) /*export*/  ALCboolean    alcIsExtensionPresent( ALCdevice *device, const ALCchar *extname );
extern(C) /*export*/  void *        alcGetProcAddress( ALCdevice *device, const ALCchar *funcname );
extern(C) /*export*/  ALCenum       alcGetEnumValue( ALCdevice *device, const ALCchar *enumname );
extern(C) /*export*/  ALCchar *     alcGetString( ALCdevice *device, ALCenum param );
extern(C) /*export*/  void          alcGetIntegerv( ALCdevice *device, ALCenum param, ALCsizei size, ALCint *data );
extern(C) /*export*/  ALCdevice*    alcCaptureOpenDevice( const ALCchar *devicename, ALCuint frequency, ALCenum format, ALCsizei buffersize );
extern(C) /*export*/  ALCboolean    alcCaptureCloseDevice( ALCdevice *device );
extern(C) /*export*/  void          alcCaptureStart( ALCdevice *device );
extern(C) /*export*/  void          alcCaptureStop( ALCdevice *device );
extern(C) /*export*/  void          alcCaptureSamples( ALCdevice *device, ALCvoid *buffer, ALCsizei samples );




//typedef ALCcontext * ( *LPALCCREATECONTEXT) (ALCdevice *device, const ALCint *attrlist);
//typedef ALCboolean ( *LPALCMAKECONTEXTCURRENT)( ALCcontext *context );
//typedef void ( *LPALCPROCESSCONTEXT)( ALCcontext *context );
//typedef void ( *LPALCSUSPENDCONTEXT)( ALCcontext *context );
//typedef void ( *LPALCDESTROYCONTEXT)( ALCcontext *context );
//typedef ALCcontext * ( *LPALCGETCURRENTCONTEXT)( void );
//typedef ALCdevice * ( *LPALCGETCONTEXTSDEVICE)( ALCcontext *context );
//typedef ALCdevice * ( *LPALCOPENDEVICE)( const ALCchar *devicename );
//typedef ALCboolean ( *LPALCCLOSEDEVICE)( ALCdevice *device );
//typedef ALCenum ( *LPALCGETERROR)( ALCdevice *device );
//typedef ALCboolean ( *LPALCISEXTENSIONPRESENT)( ALCdevice *device, const ALCchar *extname );
//typedef void * ( *LPALCGETPROCADDRESS)(ALCdevice *device, const ALCchar *funcname );
//typedef ALCenum ( *LPALCGETENUMVALUE)(ALCdevice *device, const ALCchar *enumname );
//typedef const ALCchar* ( *LPALCGETSTRING)( ALCdevice *device, ALCenum param );
//typedef void ( *LPALCGETINTEGERV)( ALCdevice *device, ALCenum param, ALCsizei size, ALCint *dest );
//typedef ALCdevice * ( *LPALCCAPTUREOPENDEVICE)( const ALCchar *devicename, ALCuint frequency, ALCenum format, ALCsizei buffersize );
//typedef ALCboolean ( *LPALCCAPTURECLOSEDEVICE)( ALCdevice *device );
//typedef void ( *LPALCCAPTURESTART)( ALCdevice *device );
//typedef void ( *LPALCCAPTURESTOP)( ALCdevice *device );
//typedef void ( *LPALCCAPTURESAMPLES)( ALCdevice *device, ALCvoid *buffer, ALCsizei samples );


extern(C) /*export*/  ALboolean     alutInit (int *argcp, char **argv);
extern(C) /*export*/  ALboolean     alutInitWithoutContext (int *argcp, char **argv);
extern(C) /*export*/  ALboolean     alutExit ();
extern(C) /*export*/  ALenum        alutGetError ();
extern(C) /*export*/  byte *        alutGetErrorString (ALenum error);
extern(C) /*export*/  ALuint        alutCreateBufferFromFile (const char *fileName);
extern(C) /*export*/  ALuint        alutCreateBufferFromFileImage (const ALvoid *data, ALsizei length);
extern(C) /*export*/  ALuint        alutCreateBufferHelloWorld ();
extern(C) /*export*/  ALuint        alutCreateBufferWaveform (ALenum waveshape, ALfloat frequency, ALfloat phase, ALfloat duration);
extern(C) /*export*/  ALvoid *      alutLoadMemoryFromFile (const char *fileName, ALenum *format, ALsizei *size, ALfloat *frequency);
extern(C) /*export*/  ALvoid *      alutLoadMemoryFromFileImage (const ALvoid *data, ALsizei length, ALenum *format, ALsizei *size, ALfloat *frequency);
extern(C) /*export*/  ALvoid *      alutLoadMemoryHelloWorld (ALenum *format, ALsizei *size, ALfloat *frequency);
extern(C) /*export*/  ALvoid *      alutLoadMemoryWaveform (ALenum waveshape, ALfloat frequency, ALfloat phase, ALfloat duration, ALenum *format, ALsizei *size, ALfloat *freq);
extern(C) /*export*/  byte *        alutGetMIMETypes (ALenum loader);
extern(C) /*export*/  ALint         alutGetMajorVersion ();
extern(C) /*export*/  ALint         alutGetMinorVersion ();
extern(C) /*export*/  ALboolean     alutSleep (ALfloat duration);
extern(C) /*export*/  void          alutLoadWAVFile (ALbyte *fileName, ALenum *format, void **data, ALsizei *size, ALsizei *frequency, ALboolean *loop);
extern(C) /*export*/  void          alutLoadWAVMemory (ALbyte *buffer, ALenum *format, void **data, ALsizei *size, ALsizei *frequency, ALboolean *loop);
extern(C) /*export*/  void          alutUnloadWAV (ALenum format, ALvoid *data, ALsizei size, ALsizei frequency);
