import std.stdio;
import std.string;
import std.stream;
import win32.windows;
import alut;
import vorbisfile;

struct OggVorbis_File{
  int aaa[180] ;
}

struct memOggBuffer{
  ubyte[] buf  ;
  long    pos  ;
} ;

memOggBuffer memOgg_open(string fname)
{
  memOggBuffer mob ;
  
  mob.buf.length = std.file.getSize(fname) ;
  BufferedFile infile = new BufferedFile(fname) ;

  if( mob.buf.length>0 ){
    infile.read(mob.buf) ;
  }
  mob.pos=0 ;
  
  return(mob) ;
}

int memOgg_read(void* _ptr, int size, int nmemb, void* _mob)
{
  ubyte        *ptr = cast(ubyte*)(_ptr) ;
  memOggBuffer *mob = cast(memOggBuffer*)(_mob) ;
  int ret ;

  writef("size=%d, nmemb=%d, mob.pos=%d, mob.buflen=%d\n",size,nmemb,mob.pos,mob.buf.length) ;

  if( _mob==null ) return(-1) ;
  if( (mob.pos>=mob.buf.length) || (mob.pos<0) ) return(0) ;

  if( mob.pos + size*nmemb >= mob.buf.length ){
    int len=mob.buf.length-mob.pos ;
    ptr[0..len] = mob.buf[mob.pos .. mob.pos+len] ;
    ret = len/size ;
    mob.pos=mob.buf.length ;
    return(ret) ;
  }
  ptr[0..nmemb*size] = mob.buf[mob.pos .. mob.pos+nmemb*size] ;
  mob.pos += nmemb*size ;
  return(nmemb) ;
}

int memOgg_seek(void* _mob, long offset, int whence)
{
  memOggBuffer *mob = cast(memOggBuffer*)(_mob) ;

  if( _mob==null || mob.pos<0 ) return(-1) ;
  if( offset<0 ){
    mob.pos=-1 ;
    return(-1) ;
  }

  int newpos ;
  switch(whence){
  case 0 : //SEEK_SET
    newpos = offset ;
    break ;
  case 1 : //SEEK_CUR
    newpos = mob.pos + offset ;
    break ;
  case 2 : //SEEK_END ;
    newpos = mob.pos + offset ;
    break ;
  defalut :
    return(-1) ;
  }
  if( newpos<0 ) return(-1) ;

  mob.pos = newpos ;

  return(0) ;
}

int memOgg_tell(void* _mob)
{
  memOggBuffer *mob = cast(memOggBuffer*)(_mob) ;
  if( _mob==null ) return(-1) ;

  return(mob.pos) ;
}


int memOgg_close(void* _mob)
{
  writef("called close\n") ;
  
  memOggBuffer *mob = cast(memOggBuffer*)(_mob) ;
  if( _mob==null ) return(-1) ;

  delete mob.buf ;
  delete mob ;
  
  return(0) ;
}



extern (C) int ov_fopen(const char *path, OggVorbis_File *vf) ;
extern (C) int ov_open_callbacks(void *datasource, OggVorbis_File *vf, char *initial, int ibytes, ov_callbacks callbacks) ;
extern (C) vorbis_info *ov_info(OggVorbis_File *vf,int link);
extern (C) int ov_read(OggVorbis_File *vf,void *buffer,int length, int bigendianp,int word,int sgned,int *bitstream);
extern (C) int ov_clear(OggVorbis_File *vf);
extern (C) double ov_time_tell(OggVorbis_File *vf);
extern (C) double ov_time_total(OggVorbis_File *vf, int i);

int main(string[] args)
{

  OggVorbis_File  vf;
  vorbis_info    *vi;
  ov_callbacks    oc;
  memOggBuffer    mob ;
  int ret ;
  int current ;

  oc.read_func  = &memOgg_read  ;
  oc.seek_func  = &memOgg_seek  ;
  oc.tell_func  = &memOgg_tell  ;
  oc.close_func = &memOgg_close ;
  
  mob = memOgg_open(args[1]) ;
  ret = ov_open_callbacks(&mob, &vf, null, 0, oc); writef("ret=%d\n",ret) ;
  //ret = ov_fopen( toStringz(args[1]), &vf) ;
  vi=ov_info(&vf,-1);
  writef("cannels=%d  version=%d  rate=%d\n",vi.channels,vi._version,vi.rate) ;

  ALCdevice  *device;
  ALCcontext *context;
  ALuint source ;
  ALuint buffer[] ;
  int    usedbuf ;
  ALint  state, n;
  ALenum format = vi.channels == 1 ? AL_FORMAT_MONO16 : AL_FORMAT_STEREO16;
  int    size ;
  
  device  = alcOpenDevice(null);
  context = alcCreateContext(device, null);
  alcMakeContextCurrent(context);
  alGenSources(1, &source);

  
  ubyte[] pcmdata ;
  pcmdata.length=8192 ;

  buffer.length=64 ;
  usedbuf=0 ;

  while(-1){
    alGetSourcei(source, AL_BUFFERS_QUEUED, &n);
    writef("Queued buffers = %d\n",n) ;
    for( int i=0 ; i<(buffer.length-n) ; i++ ){
      size = ov_read(&vf, pcmdata.ptr, pcmdata.length, 0,2,1,&current) ;
      if( size<=0 ) break ;
      alGenBuffers(1, &buffer[usedbuf]);
      writef("size = %d usedbuf=%d time=%f\n",size,usedbuf, ov_time_tell(&vf)) ;
      alBufferData(buffer[usedbuf], format, pcmdata.ptr, size, vi.rate);
      alSourceQueueBuffers(source, 1, &buffer[usedbuf]);
      usedbuf = usedbuf+1 ;
    }
    alGetSourcei(source, AL_SOURCE_STATE, &state);
    if( state != AL_PLAYING ){
      alSourcePlay(source);
    }
    while(-2){
      alGetSourcei(source, AL_BUFFERS_PROCESSED, &n) ;
      if( n!=0 ){
	break ;
      }
      Sleep(1000);
    }
    for( int i=0 ; i<n ; i++ ){
      alSourceUnqueueBuffers(source, 1, &buffer[i]);
      alDeleteBuffers(1, &buffer[i]) ;
    }
    for( int i=0 ; i<buffer.length-n ; i++ ){
      buffer[i]=buffer[n+i] ;
    }
    usedbuf-=n ;
    
    if( size<=0 ) break ;
  }
  ov_clear(&vf);
  //  alGetSourcei(source, AL_SOURCE_STATE, &state);
  //  if( state != AL_PLAYING ) {
  //    alSourcePlay(source);
  //  }
  //  while( -1 ){
  //    alGetSourcei(source, AL_SOURCE_STATE, &state) ;
  //    if( state != AL_PLAYING ) break ;
  //    Sleep(1);
  //  }
  alDeleteSources(1, &source);
  alcMakeContextCurrent(null);
  alcDestroyContext(context);
  alcCloseDevice(device);
  
  return(0) ;
  
}
