//
//
//

struct ogg_sync_state{
  ubyte *data ;
  int   storage ;
  int   fill ;
  int   returned ;
  int   unsynced ;
  int   headerbytes ;
  int   bodybytes ;
} ;

struct vorbis_info{
  int   _version ;
  int   channels ;
  int   rate ;
  int   bitrate_upper ;
  int   bitrate_nominal ;
  int   bitrate_lower ;
  int   bitrate_window ;
  void  *coldec_setup ;
} ;

struct vorbis_comment{
  char **user_comments ;
  int  *comment_lengths ;
  int   comments ;
  char *vendor ;
} ;

struct ogg_stream_state{
  ubyte *body_data ;
  int   body_strage ;
  int   body_fill ;
  int   body_returned ;

  int   *lacing_vals ;
  long  *granule_vals ;

  int   lacing_storage ;
  int   lacing_fill ;
  int   lacing_packet ;
  int   lacing_returned ;

  ubyte header[282] ;

  int   e_o_s ;
  int   b_o_s ;

  int   serialno ;
  int   pageno ;

  long  packetno ;

  long  granulepos ;
} ;

struct vorbis_dsp_state{
  int  analysisp ;
  vorbis_info *vi ;

  float **pcm ;
  float **pcmret ;
  int   pcm_storage ;
  int   pcm_current ;
  int   pcm_returned ;

  int   preextrapolate ;
  int   eofflag ;

  int   lW ;
  int   W  ;
  int   nW ;
  int   centerW ;

  long  granulepos ;
  long  sequence ;

  long  glue_bits ;
  long  type_bits ;
  long  floor_bits ;
  long  res_bits  ;

  void  *backend_state ;
} ;

struct oggpack_buffer{
  int   endbyte ;
  int   endbit ;
  ubyte *buffer ;
  ubyte *ptr ;
  int   strage ;
} ;

struct alloc_chain{
  void        *ptr  ;
  alloc_chain *next ;
}

struct vorbis_block{
  float **pcm ;
  oggpack_buffer opb ;

  int   lW ;
  int   W  ;
  int   nW ;
  int   pcmend ;
  int   mode ;

  int   eofflag ;
  long  granulepos ;
  long  sequence ;
  vorbis_dsp_state *vd ;

  void  *localstore ;
  int   localtop ;
  int   localalloc ;
  int   totaluse ;
  alloc_chain *reap ;

  int   glue_bits ;
  int   time_bits ;
  int   floor_bits ;
  int   res_bits ;

  void  *internal ;
} ;

struct ov_callbacks{
  int function(void*, int, int, void*) read_func  ;
  int function(void*, long, int)       seek_func  ;
  int function(void*)                  close_func ;
  int function(void*)                  tell_func  ;
} ;




//struct OggVorbis_File{
//  void *datasource ;
//  int  seekable;
//  long offset ;
//  long end    ;
//  ogg_sync_state oy ;
//
//  int  links ;
//  long *offsets ;
//  long *dataoffsets ;
//  int  *serialnos ;
//  long *pcmlengths ;
//
//  vorbis_info    *vi ;
//  vorbis_comment *vc ;
//
//  long pcm_offset ;
//  int  ready_state ;
//  int  current_serialno ;
//  int  current_link ;
//  double bittrack ;
//  double samptrack ;
//
//  ogg_stream_state os ;
//  
//  vorbis_dsp_state vd ;
//  vorbis_block     vb ;
//  
//  ov_callbacks callbacks ;
//}
