import win32.windows;
import std.string;
import std.stdio;
import win32frame.writek;
import win32frame.WindowBase ;
import win32frame.ToolTip ;
import win32frame.StatusBar ;

class WindowObject : WindowBase {
  int winX=CW_USEDEFAULT ;
  int winY=CW_USEDEFAULT ;
  int winW=CW_USEDEFAULT ;
  int winH=CW_USEDEFAULT ;
  int style  =0 ;
  int exstyle=0 ;
  ToolTip tooltip ;
  shared static StatusBar _statusBar ;
  shared static HWND MainWindowHWND  ;

  WindowObject[]     fitWOBJ_List ;
  uint[WindowObject] fitWOBJ_Flag ;

  
  this( string name ) {
    super(name) ;
  }

  int setPosition(int x, int y, int w, int h){
    winX = x ;
    winY = y ;
    winW = w ;
    winH = h ;
    return(0) ;
  }

  int setStyle(int style){
    this.style=style ;
    return(0) ;
  }

  int addStyle(int addstyle){
    this.style |= addstyle ;
    return(0) ;
  }

  int getStyle(){
    return(this.style) ;
  }

  int setExStyle(int exstyle){
    this.exstyle=exstyle ;
    return(0) ;
  }

  int addExStyle(int addexstyle){
    this.exstyle |= addexstyle ;
    return(0) ;
  }

  int getExStyle(){
    return(this.exstyle) ;
  }

  int addObject(WindowObject WObj, HMENU hmenu, bool fitWidth=false, bool fitHeight=false ){
    HWND tmphwnd ;
    int  ret ;
    ret = WObj.create(this.getHWND(), hmenu) ;
    tmphwnd = WObj.getHWND() ;
    if( tmphwnd != null ){
      if( fitWidth==true || fitHeight==true ){
	fitWOBJ_List.length = fitWOBJ_List.length + 1 ;
	fitWOBJ_List[(fitWOBJ_List.length-1)]=WObj ;
	fitWOBJ_Flag[WObj] = ((fitWidth==true) ? 1 : 0) + ((fitHeight==true) ? 2 : 0)  ;
      }
    }
    return( ret ) ;
  }

  int delObject(WindowObject WObj){
    if( WObj !is null ){
      int flag=0 ;
      for( int i=0 ; i<fitWOBJ_List.length ; i++ ){
	if( fitWOBJ_List[i] is WObj ){
	  fitWOBJ_Flag.remove(fitWOBJ_List[i]) ; //remove(WObj)だとダメ
	  delete fitWOBJ_List[i] ;
	  for( int j=i+1 ; j<fitWOBJ_List.length ; j++ ){
	    fitWOBJ_List[j-1]=fitWOBJ_List[j] ;
	  }
	  fitWOBJ_List.length=fitWOBJ_List.length-1 ;
	  flag=1 ;
	  break ;
	}
      }
      if( flag==0 ){
	if( this.getHWND()==WObj.getParentHWND() ){
	  delete WObj ;
	}
      }
    }
    return( 0 ) ;
  }

  int addToolTip(ToolTip TooltipOBJ){
    if( TooltipOBJ !is null ){
      int ret ;
      tooltip = TooltipOBJ ;
      ret = tooltip.create(this.getHWND()) ;
      tooltip.setClientRect() ;
      return(ret) ;
    }
    return(-1) ;
  }

  HWND getMainWinHWND(){
    return( cast(HWND)(MainWindowHWND) ) ;
  }
  
  int create(HWND phwnd, HMENU hmenu){
    return( lowcreate( exstyle, style, winX,winY,winW,winH, phwnd, hmenu) ) ;
  }

  int show(int cmdshow=SW_SHOW){
    if( this.getHWND() !=null ){
      return( ShowWindow(this.getHWND(),cmdshow) ) ;
    }
    return(-1) ;
  }

  int hide(){
    if( this.getHWND() !=null ){
      return( ShowWindow(this.getHWND(),SW_HIDE) ) ;
    }
    return(-1) ;
  }

  int enable(){
    if( this.getHWND()!=null ){
      return(EnableWindow(this.getHWND(), TRUE)) ;
    }
    return(-1) ;
  }

  int disable(){
    if( this.getHWND()!=null ){
      return(EnableWindow(this.getHWND(), FALSE)) ;
    }
    return(-1) ;
  }

  int printStatusbar(string str){
    if( _statusBar !is null ){
      StatusBar statbar = cast(StatusBar)(_statusBar) ;
      statbar.setText(str) ;
    }
    return(0) ;
  }
  

  override LRESULT preproc(HWND hwnd , UINT msg , WPARAM wp , LPARAM lp){
    switch( msg ){
    case WM_CREATE :
      RECT rc ;
      GetClientRect( hwnd, &rc ) ;
      winX=0 ;
      winY=0 ;
      winW=rc.right  ;
      winH=rc.bottom ;
      break ;
      
    case WM_MOVE :
      winX=LOWORD(lp) ;
      winY=HIWORD(lp) ;
      break ;

    case WM_SIZE :
      winW=LOWORD(lp) ;
      winH=HIWORD(lp) ;
      
      RECT rc ;
      GetClientRect( hwnd, &rc ) ;
      RECT rc_parent ;
      GetWindowRect( hwnd, &rc_parent ) ;
      
      foreach_reverse( i, fitWOBJ ; fitWOBJ_List ){
	if( fitWOBJ !is null ){
	  RECT rc_child ;
	  GetWindowRect( fitWOBJ.getHWND(), &rc_child ) ;
	  rc_child.top    = rc_child.top    - rc_parent.top  ;
	  rc_child.bottom = rc_child.bottom - rc_parent.top  ;
	  rc_child.left   = rc_child.left   - rc_parent.left ;
	  rc_child.right  = rc_child.right  - rc_parent.left ;
	  
	  switch( fitWOBJ_Flag[fitWOBJ] ){
	  case 1 : // fit Width
	    MoveWindow( fitWOBJ.getHWND(), 0,  rc_child.top, (rc.right - rc.left), (rc_child.bottom - rc_child.top) , true ) ;
	    break ;
	  case 2 : // fit Height
	    MoveWindow( fitWOBJ.getHWND(), rc_child.left, 0, (rc_child.right - rc_child.left), (rc.bottom - rc.top) , true ) ;
	    break ;
	  case 3 :
	    MoveWindow( fitWOBJ.getHWND(), 0,0, (rc.right - rc.left), (rc.bottom - rc.top) , true ) ;
	    break ;
	  default : core.exception.onSwitchError() ;
	  }
	}
      }
      break ;
      
    default : break ;
    }
    
    return( this.proc(hwnd , msg , wp , lp) ) ;
  }

  override LRESULT presubproc(HWND hwnd , UINT msg , WPARAM wp , LPARAM lp){
    if( msg==WM_SIZE ){
      if( tooltip !is null ){
	tooltip.reNewClientRect() ;
      }
    }
    return( this.subproc(hwnd , msg , wp , lp) ) ;
  }

}
